
/* filterWord.h
 * Copyright (C) 2011, Antonio Fariña, all rights reserved.
 *
 * filterWord.h: Obtains a canonical word associated to a given word.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *
 */



#include "valstring.h"
#include "defValues.h"
#include "hashStopWords.h"
#include "porter.h"

	
#define IS_STOPWORD 0
#define IS_NORMALWORD 1

struct Scanonical {        //used only for calling "getCanonical".
	byte word[MAX_SIZE_OF_WORD+1];
	unsigned int size;
	int type;               //{ 1 --> WORD, 0 --> STOPWORD}
};	
typedef struct Scanonical tCanonical;

/*------------------------------------------------------------------
 Obtains the canonical word of a given "word-variant".
 ------------------------------------------------------------------ */
int getCanonical(tCanonical *canonical,  byte *word, uint size, stt_hash stopWordsHash);
