
/* kBitArray.h
 * Copyright (C) 2011, Antonio Fariña, all rights reserved.
 *
 * kBitArray.h: Definition of an array of uints represented with k-bits each.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *
 */

#include "basics.h"
 
struct akbitArr {
	uint *data;	   /* uint * contains space for the array of kbit elements	*/
	uint size;     /* number of kbitElements    */
	uint elemSize; /* number of bits of each element*/	
	uint totalInts; /* number of ints used */
};

typedef struct akbitArr *t_kBitArray;

	/*********/
	t_kBitArray create_kBitArray (uint size, uint elemSize);
	uint getKBitArray(t_kBitArray V,uint i);
	void setKBitArray(t_kBitArray V, uint i, uint value);
	void destroy_kBitArray (t_kBitArray kBitArray);


	#define getKBitArrayMacro mybitread  //mybitread(answ, v, p, len)




