#ifndef  BUILDFACADE_H_INCLUDED
#define BUILDFACADE_H_INCLUDED

/* only for getTime() */
#include <sys/time.h>
#include <sys/resource.h>

#include "utils/valstring.h"
#include "utils/defValues.h"
#include "utils/fileInfo.h"
#include "utils/dataTypesFacade.h"
#include "utils/hashWords.h"
#include "utils/hashStopWords.h"
#include "utils/filterWord.h"
#include "utils/basics.h"
//#include "utils/bc.h"

#include "utils/horspool.h"
#include "utils/errors.c"
#include "utils/timer.h"

#define FILLERUINT  0000

#ifndef uchar
#define uchar unsigned char
#endif
#ifndef uint
#define uint  unsigned int
#endif
#ifndef ulong
#define ulong unsigned long
#endif

#define STRLEN(str,len) \
{len=0; \
 byte *ptr = str; \
 while(*ptr++) len++; \
}

#define ADDLEN(str,len) \
{byte *ptr = str; \
	while(*ptr++) len++; \
}

//
//	typedef struct {   //aux structure used to sort vectors (for words of separators)
//		uint slot;       //depending on the values of the associated hash table.
//		byte *word;
//	} tauxslots;
//
//
//	typedef struct SzoneMem {        //a large block of memory to load a file into mem.
//		byte *zone;  //block of mem.
//		uint size;  //number of bytes	 	 
//	} tZoneMem;
//
//	typedef struct {		
//		uint *occs;			//ptr to the begining of the occs of word i in zoneOccs.		
//
//		uint sampleK;		// sample over the occurrences of each word 
//
//		uint *zoneOccs;		//bitVector with buckets [Abs|bcOff][Abs|bcOff]...
//		uint zoneOccsSize;	//in bits
//		uint numBuckets;	//in numberOfBuckets
//
//		uint occsBucketSize;// kbits (bits offset into zoneMem)
//		uint absOffsetSize; // kbits (bits to represent a jump)
//		uint bcOffsetSize;  // kbits (bits for a ptr to bcsZone)
//				
//		byte *bcs;			// byteCodes with differential encoding of gaps.
//		uint bcsSize;		// in bytes
//	}toccs;
//
//
//	/**the WCSA index structures... */
//	typedef struct {
//
//		stt_hash stopwordshash;	/* A hash table with the stopwords */	
//		char * stopwordsfilename;
//							
//		/* words */
//		tZoneMem wordsZone;    /** mem zone to keep the words in the vocab of ETDC */ 
//		unsigned long nwords;	 /** number of words in the vocab of ETDC */		
//		byte **words;			     /** array of ptr to words. */
//		
//		uint *indexedWords;    /** a bitmap that tells if a word is indexed or not */
//				
//		uint ncanonicals;				 /** the number of canonical words */
//		tZoneMem canonicalsZone; /** mem zone to keep the canonical words */
//		byte **canonicals;			 /** array of ptrs to canonical words */
//		
//		uint *varsCanonicals;   /* Directory that points to the begin of the codes of the ids of the variants in "varsETDC"... +1 virtual slot at the end */
//		uint varsETDCSize;			/* Number of bytes. */
//		byte *varsETDC;		      /* Bytes of the ids encoded with ETDC */
//				
//		toccs occs;	
//		
//		uint *freqs;	
//		uint *lenList;	
//
//		byte *text;  		 //the text /compressed text. 
//		uint textSize;		 //the size of the compressed source text (in bytes)
//		uint sourceTextSize; //the size of the source text.
//		uint Nwords;	    /** number of words in the text. */		
//		uint blockSize;
//
//	}twcsa;


// 	uint sampleK;
// 	uint bucksize;
// 	uint absBits;
// 	uint bcBits;
// 	uint *zoneoccs;
// 	byte *bcs;


/** ******************************************************************************
    * Interface (from pizza chili) for using the WCSA index
*********************************************************************************/

/* Error management */

        /* Returns a string describing the error associated with error number
          e. The string must not be freed, and it will be overwritten with
          subsequent calls. */

char *error_index (int e);

/* Building the index */

        /* Creates index from text[0..length-1]. Note that the index is an 
          opaque data type. Any build option must be passed in string 
          build_options, whose syntax depends on the index. The index must 
          always work with some default parameters if build_options is NULL. 
          The returned index is ready to be queried. */

int build_index (uchar *text, ulong length, char *build_options, void **index);

        /*  Saves index on disk by using single or multiple files, having 
          proper extensions. */

int save_index (void *index, char *filename);

        /*  Loads index from one or more file(s) named filename, possibly 
          adding the proper extensions. */

int load_index (char *filename, void **index);

        /* Frees the memory occupied by index. */

int free_index (void *index);

        /* Gives the memory occupied by index in bytes. */

int index_size(void *index, ulong *size);

/* Querying the index */

        /* Writes in numocc the number of occurrences of the substring 
          pattern[0..length-1] found in the text indexed by index. */

int count (void *index, uchar *pattern, ulong length, ulong *numocc);

        /* Writes in numocc the number of occurrences of the substring 
          pattern[0..length-1] in the text indexed by index. It also allocates
          occ (which must be freed by the caller) and writes the locations of 
          the numocc occurrences in occ, in arbitrary order.  */

int locate (void *index, uchar *pattern, ulong length, ulong **occ, 
        ulong *numocc);

        /* Gives the length of the text indexed */

int get_length(void *index, ulong *length);

/* Accessing the indexed text  */

        /*  Allocates snippet (which must be freed by the caller) and writes 
          the substring text[from..to] into it. Returns in snippet_length the 
          length of the text snippet actually extracted (that could be less 
          than to-from+1 if to is larger than the text size). */

int extract (void *index, ulong from, ulong to, uchar **snippet, 
        ulong *snippet_length);

        /* Displays the text (snippet) surrounding any occurrence of the 
          substring pattern[0..length-1] within the text indexed by index. 
          The snippet must include numc characters before and after the 
          pattern occurrence, totalizing length+2*numc characters, or less if 
          the text boundaries are reached. Writes in numocc the number of 
          occurrences, and allocates the arrays snippet_text and 
          snippet_lengths (which must be freed by the caller). The first is a 
          character array of numocc*(length+2*numc) characters, with a new 
          snippet starting at every multiple of length+2*numc. The second 
          gives the real length of each of the numocc snippets. */

int display (void *index, uchar *pattern, ulong length, ulong numc, 
        ulong *numocc, uchar **snippet_text, ulong **snippet_lengths);

        /*  Obtains the length of the text indexed by index. */

int length (void *index, ulong *length);




/** *******************************************************************************************/
/** Building part of the index ****************************************************************/
//int build_WCSA (uchar *text, ulong length, char *build_options, void **index, char *outbasename);
//int build_WCSA (uchar *text, ulong length, char *stopwordsfile, void **index);
//int build_WCSA (uchar *inbasename, uint blockSize, uint sampleK, void **index);
int build_WCSA (uchar *inbasename, uint blockSize, uint sampleK, char *stopwordsfile, void **index);

/** *******************************************************************************************/
/** Search part of the index ******************************************************************/
// Definitions of some PUBLIC function prototipes.

	//loading/freeing the data structures into memory.
	
    void loadStructs(twcsa *wcsa, char *basename);	
	twcsa *loadWCSA(char *filename);	
	void destroyStructsFacade(twcsa *wcsa);
	

		//recovers the source text by calling display (either only once or "len" times)
	void recoverSourceText1(twcsa *wcsa, char *basename, char *ext, uint sourceTextSize);

	//***Searching for a TEXT pattern ...
	
	
//	//int parseWordToCanonicalID(twcsa *wcsa, byte *aWord, uint size);
//	int parseWordToCanonicalID(twcsa *wcsa, byte *aWord); // <<== aWord MUST!! end in '\0'
//	
	
		//extracts the ids of the valid words of a "plain text".
	void parseTextIntoIntegers(twcsa *wcsa, byte *textPattern, uint patLen, uint *integerPattern, uint *sizeIntegers) ;
		
 		//counts the occurrences of a given text pattern.
	int countTextOcurrences(twcsa *wcsa, byte *textPattern);
	
 		//returns the offsets (to the source text) where of a given text pattern appears.	
	uint *locateTextOcurrences(twcsa *wcsa, byte *textPattern, int *numberOccurrences);
	
 		//shows a snippet with the text around the ocurrences of a pattern.	
	int displayTextOcurrences(void *index, uchar *pattern, ulong length, uint radixDisplay);


/** ***********************************************************************************
  * WORD-ORIENTED QUERY FUNCTIONS: LocateWord and DisplayWord
  * ***********************************************************************************/  
	/* Writes in numocc the number of occurrences of the substring 
	  pattern[0..length-1] in the text indexed by index. It also allocates
	  occ (which must be freed by the caller) and writes the locations of 
	  the numocc occurrences in occ, in arbitrary order. These occurrences
	  refer to the offsets in TOH where the caller could start a display
	  operation. So locateWord implies synchronization using B.
	  ** Parameter kbefore sets locateWord not to obtain the offset in TOH of the
	     searched word, but the offset in TOH of k-before words before.	  
	*/	  
	  
int locateWord(void *index, uchar *pattern, ulong length, ulong **occ, ulong *numocc, uint kbefore);




// Definitions of PRIVATE functions

	// binary search algorithm... needed by display().
	//Auxiliary functions

	uint structsSizeDisk(twcsa *wcsa);
	uint structsSizeMem(twcsa *wcsa);
	void printInfo(twcsa *wcsa);
	void printInfoReduced(twcsa *wcsa); 
	//double getTime(void);
	


#endif 
