#include "bc.h"

 /*decode for ETDC*/
/* byte *etdc is a encoded sequence*/
/* receives a pos... decodes 1 code from there on an returns the new pos */
uint decode (byte *etdc, register uint pos, uint *num) {
	register uint k=pos;
	register uint j;
	j=0;
	while (etdc[pos] >=128) {
		j = j * 128 + (etdc[pos] - 128);
		pos++;
	}
	j = j * 128 + etdc[pos];
	j += TABLABASE[pos-k]; //the position of the word in the vocabulary
	pos++;
	*num = j;
	return pos;
}

/*------------------------------------------------------------------
   Given a codeword stored as a number, it 
   obtains the number of bytes and writes they to *code as an array.	
------------------------------------------------------------------*/
void getBytes(unsigned char *code, unsigned long number, int numBytes) {
	unsigned long tmp;
	int i;
	unsigned char *pt;
	
	tmp = LE_LONG32(number);
	tmp = LINE_UP (tmp,numBytes);
	pt = (unsigned char *)&tmp;
	
	for (i=0;i<numBytes;i++) {
		code[i]= pt[i];				
	}	
}

/*------------------------------------------------------------------
 GetCode
 gets the codeword of a word ranked "position"
 returns an unsigned long value (up to 4 bytes codewords) in "*codeword"
         the number of bytes of the codeword.
------------------------------------------------------------------*/
void getCode(register unsigned long position,
						register unsigned long *codeword, register unsigned long *k){
	unsigned long despl;
	*k=1;
	*codeword = (position& 0x7F);
	position  >>= 7;
	despl=8;

	while (position > 0) {
		position -=1;
		*codeword |= (( (position & 0x7F) | 0x80 )<<despl );
		despl += 8;
		position  >>= 7;
		(*k) ++;
	}	
}

/* sen probar*/
unsigned long getLenETDC(register unsigned long position){
	unsigned long despl;
	unsigned long k;
	k=1;
	position  >>= 7;
	despl=8;

	while (position > 0) {
		position -=1;
		despl += 8;
		position  >>= 7;
		(k) ++;
	}	
	return k;
}

/*sin probar */
/** Lenght of the compressed text if all the words appear just once 
  * when the number of words in the vocabulary is "numWords"
  */
unsigned long getAcumSizeCodesETDCFreq1(register unsigned long numWords){
	unsigned long i,next, bytes;
	unsigned long total;
	total=0; bytes =1; next = TABLABASE[bytes];
	for (i=1; i<= numWords;i++) {
		total += (bytes);
		if (i==next) {
				bytes++;
				next = TABLABASE[bytes];
		}
	}	
	return total;
}
//uint decode (byte *bc, uint pos, uint *num) {
//			pbeg = text; pend = top;
//
//			while ( pbeg < pend )   {
//				//Reads and decodes a codeword
//				codeStart = pbeg;
//				j=0;
//				while (*pbeg >=128) {
//					j = j * 128 + (*pbeg - 128);
//					pbeg++;
//				}
//				j = j * 128 + *pbeg;
//				j += TABLABASE[pbeg - codeStart]; //the position of the word in the vocabulary
//
//				pbeg++;
//				writeWord(outWriter,words[j].word, words[j].size);
//			}/* inner while*/



void check_BC_works(uint limit){
	uint num, size,i;
	num=0; SIZE_DEC_TO_BC(num,size);fprintf(stderr,"\n num %6d is encoded with %d bytes",num,size);
	num=1; SIZE_DEC_TO_BC(num,size);fprintf(stderr,"\n num %6d is encoded with %d bytes",num,size);
	num=128-1; SIZE_DEC_TO_BC(num,size);fprintf(stderr,"\n num %6d is encoded with %d bytes",num,size);
	num=128+0; SIZE_DEC_TO_BC(num,size);fprintf(stderr,"\n num %6d is encoded with %d bytes",num,size);
	num=128+1; SIZE_DEC_TO_BC(num,size);fprintf(stderr,"\n num %6d is encoded with %d bytes",num,size);

	num=128*128-1; SIZE_DEC_TO_BC(num,size);fprintf(stderr,"\n num %6d is encoded with %d bytes",num,size);
	num=128*128+0; SIZE_DEC_TO_BC(num,size);fprintf(stderr,"\n num %6d is encoded with %d bytes",num,size);
	num=128*128+1; SIZE_DEC_TO_BC(num,size);fprintf(stderr,"\n num %6d is encoded with %d bytes",num,size);
	
	
	byte code[10];
	for (i=0;i<limit;i++) {
		uint pos =0;
		num =i;
		DEC_TO_BC(code, pos, num);
		pos =0;
		BC_TO_DEC(code,pos,num);
		if (i != num) {fprintf(stderr,"\n DISTINTOS !!!!");
			return ;
		}
	}	
	fflush(stderr);
}


