#ifndef BC_INCLUDED
#define BC_INCLUDED
#include "basics.h"
const unsigned long TABLABASE[5] = {0,128,16512,2113664,270549120};

/*decode for ETDC*/
/* byte *etdc is a encoded sequence*/
/* receives a pos... decodes 1 code from there on an returns the new pos */
uint decode (byte *etdc, register uint pos, uint *num);

/*decode for ETDC*/
/* byte *etdc is a encoded sequence*/
/* receives a pos... decodes 1 code from there on an returns the new pos */
uint decode (byte *etdc, register uint pos, uint *num) ;

/*------------------------------------------------------------------
   Given a codeword stored as a number, it 
   obtains the number of bytes and writes they to *code as an array.	
------------------------------------------------------------------*/
void getBytes(unsigned char *code, unsigned long number, int numBytes);

/*------------------------------------------------------------------
 GetCode
 gets the codeword of a word ranked "position"
 returns an unsigned long value (up to 4 bytes codewords) in "*codeword"
         the number of bytes of the codeword.
------------------------------------------------------------------*/
void getCode(register unsigned long position,
						register unsigned long *codeword, register unsigned long *k);

/* sen probar*/
unsigned long getLenETDC(register unsigned long position);

/*sin probar */
/** Lenght of the compressed text if all the words appear just once 
  * when the number of words in the vocabulary is "numWords"
  */
unsigned long getAcumSizeCodesETDCFreq1(register unsigned long numWords);


#define CEILLOG_2(x,v)                      \
do {                                        \
    register unsigned _B_x = (x) - 1;       \
    (v) = 0;                                \
    for (; _B_x ; _B_x>>=1, (v)++);         \
} while(0)                 



#define DEC_TO_BC(bc, pos, num)             \
{ while (num >= 128) {                      \
 bc[pos++] = (byte)((num & 127) + 128);     \
 num = (num >> 7);                          \
}                                           \
bc[pos++] = (byte) num;                     \
}

#define SIZE_DEC_TO_BC(num,size)            \
{uint numtmp=num;                           \
  size=0;                                   \
  while (num >= 128) {                      \
   size++;                                  \
   num = (num >> 7);                        \
  }                                         \
size++; num=numtmp;                         \
}			
			
#define BC_TO_DEC(bc,pos,num) \
 { \
 	 register uint _pot, _x; \
 	 _pot=1; \
 	 _x = bc[pos++]; \
 	 num=0; \
 	 while (_x >= 128) { \
 	 	num = num + (_x-128)*_pot; \
 	 	_x=bc[pos++]; \
 	 	_pot<<=7; \
 	 } \
 	 num=num + _x*_pot; \
 }

void check_BC_works(uint limit);


#endif
