
#ifndef DATATYPEFACEDE_INCLUDED
#define DATATYPEFACEDE_INCLUDED
#include "hashStopWords.h"

	typedef struct {   //aux structure used to sort vectors (for words of separators)
		uint slot;       //depending on the values of the associated hash table.
		byte *word;
	} tauxslots;


	typedef struct SzoneMem {        //a large block of memory to load a file into mem.
		byte *zone;  //block of mem.
		uint size;  //number of bytes	 	 
	} tZoneMem;

	typedef struct {		
		uint *occs;			//ptr to the begining of the occs of word i in zoneOccs.		

		uint sampleK;		// sample over the occurrences of each word 

		uint *zoneOccs;		//bitVector with buckets [Abs|bcOff][Abs|bcOff]...
		uint zoneOccsSize;	//in bits
		uint numBuckets;	//in numberOfBuckets

		uint occsBucketSize;// kbits (bits offset into zoneMem)
		uint absOffsetSize; // kbits (bits to represent a jump)
		uint bcOffsetSize;  // kbits (bits for a ptr to bcsZone)
				
		byte *bcs;			// byteCodes with differential encoding of gaps.
		uint bcsSize;		// in bytes
	}toccs;


	/**the WCSA index structures... */
	typedef struct {

		stt_hash stopwordshash;	/* A hash table with the stopwords */	
		char * stopwordsfilename;
							
		/* words */
		tZoneMem wordsZone;    /** mem zone to keep the words in the vocab of ETDC */ 
		unsigned long nwords;	 /** number of words in the vocab of ETDC */		
		byte **words;			     /** array of ptr to words. */
		
		uint *indexedWords;    /** a bitmap that tells if a word is indexed or not */
				
		uint ncanonicals;				 /** the number of canonical words */
		tZoneMem canonicalsZone; /** mem zone to keep the canonical words */
		byte **canonicals;			 /** array of ptrs to canonical words */
		
		uint *varsCanonicals;   /* Directory that points to the begin of the codes of the ids of the variants in "varsETDC"... +1 virtual slot at the end */
		uint varsETDCSize;			/* Number of bytes. */
		byte *varsETDC;		      /* Bytes of the ids encoded with ETDC */
				
		toccs occs;	
		
		uint *freqs;	
		uint *lenList;	

		byte *text;  		 //the text /compressed text. 
		uint textSize;		 //the size of the compressed source text (in bytes)
		uint sourceTextSize; //the size of the source text.
		uint Nwords;	    /** number of words in the text. */		
		uint blockSize;

	}twcsa;
	
	#endif
	

