#include "filterWord.h"


/*------------------------------------------------------------------
 Obtains the canonical word of a given "word-variant".
 ----------------------------------------------------------------- */
int getCanonical(tCanonical *canonical,  byte *word, uint size, stt_hash stopWordsHash) {
	register byte *src, *dst;
	unsigned long i,addrInTH;
	
	dst= canonical->word; 
	src=word;

	for(i=0;i<size;i++)
		dst[i] = src[i];

	for (i=0;i<size;i++) {*dst++ = _toLow[*src++];} //lowercase
	
	size = stem((char *)canonical->word,0,size-1);
	canonical->word[size+1]=0;

	//fprintf(stderr,"size= %d src : %s  dst: %s\n",size,word,canonical->word);

	canonical->size =size+1;
	
	i = stinHashTable(stopWordsHash,canonical->word, canonical->size, &addrInTH);	// is it a stopword?
	if (!i) canonical->type =IS_NORMALWORD;
	else	canonical->type =IS_STOPWORD;
	//if(i) fprintf(stderr,"STOP!! size= %d src : %s  dst: %s\n",canonical->size,word,canonical->word);
}

///////////////////////////////////////////////////////////////


/*------------------------------------------------------------------
 Obtains the canonical word of a given "word-variant".
 Assumes that words ends in '\0' ==> size is not needed
 ----------------------------------------------------------------- */
int getCanonicalNoSize(tCanonical *canonical,byte *word, stt_hash stopWordsHash) {
	register byte *src, *dst;
	unsigned long i,addrInTH;
	register uint size=0;
	dst= canonical->word; 
	src=word;
	//fprintf(stderr,"size= %d src : %s  dst: %s\n",canonical->size,word,canonical->word);
	while (*src) {*dst++ = _toLow[*src++]; size++;} //lowercase
	*dst='\0';
	size = stem((char *)canonical->word,0,size-1);
	canonical->word[size+1]=0;
	canonical->size =size+1;
	

	//fprintf(stderr,"size= %d src : %s  dst: %s\n",size,word,canonical->word);
	i = stinHashTable(stopWordsHash,canonical->word, canonical->size, &addrInTH);	// is it a stopword?
	if (!i) canonical->type =IS_NORMALWORD;
	else	canonical->type =IS_STOPWORD;
  //if (i) fprintf(stderr,"STOP2 size= %d src : %s  dst: %s\n",canonical->size,word,canonical->word);

}




/** returns the ID (into the canonical array) of a variant */
//int parseWordToCanonicalID(twcsa *wcsa, byte *aWord, uint size) {
int parseWordToCanonicalID(twcsa *wcsa, byte *aWord) {
	tCanonical canonical;	
		 						  																			
		if (_Valid[*aWord]) { //either a word or a stopword		
			register uint min,max,p;	
			byte *canonicWord;		
			//getCanonical(&canonical, aWord,size, wcsa->stopwordshash);
			getCanonicalNoSize(&canonical, aWord, wcsa->stopwordshash);
			canonicWord = canonical.word;					
			
			if (canonical.type != IS_STOPWORD)  { // a "meaningfull word" (a non-stopword)
				// Binary search on the canonical words (wordsData)
				min = 0;
				max = (wcsa->ncanonicals) - 1;
				while(min < max) {
					p = (min+max)/2;
					if(strcmp((char*)canonicWord, (char*)wcsa->canonicals[p]) > 0) min = p+1;
					else max = p;
				}
				if(!strcmp((char*)canonicWord, (char*)wcsa->canonicals[min])) return min; //( min + 1 );
				else {return -1;}  // a valid word that does not appear in the source text.
			}			
			else return -1;				
		}
		else return -1;
}
