 
#include "horspool.h"

//
///***********************************************************************************************/
///*------------------------------------------------------------------
//   Given a codeword stored as a number, it 
//   obtains the number of bytes and writes they to *code as an array.	
//------------------------------------------------------------------*/
//void getBytes(unsigned char *code, unsigned long number, int numBytes) {
//	unsigned long tmp;
//	int i;
//	char *pt;
//	
//	tmp = LE_LONG32(number);
//	tmp = LINE_UP (tmp,numBytes);
//	pt = (unsigned char *)&tmp;
//	
//	for (i=0;i<numBytes;i++) {
//		code[i]= pt[i];				
//	}	
//}
//
///*------------------------------------------------------------------
// GetCode
// gets the codeword of a word ranked "position"
// returns an unsigned long value (up to 4 bytes codewords) in "*codeword"
//         the number of bytes of the codeword.
//------------------------------------------------------------------*/
//void getCode(register unsigned long position,
//						register unsigned long *codeword, register unsigned long *k){
//	unsigned long despl;
//
//	*k=1;
//	*codeword = (position& 0x7F);
//	position  >>= 7;
//	despl=8;
//
//	while (position > 0) {
//		position -=1;
//		*codeword |= (( (position & 0x7F) | 0x80 )<<despl );
//		despl += 8;
//		position  >>= 7;
//		(*k) ++;
//	}
//}

/*------------------------------------------------------------------
 Prints a code: debuging purposes only
------------------------------------------------------------------*/
void printCodigo (byte *cw, int size) {
	int i;
	byte *c;
	c=cw;
	fprintf(stderr,"\nINICIO PRINTCODIGO codeSize %d: CODIGO:",size);
	for (i=0;i<size;i++) {fprintf(stderr,"[%d]",*(c++));}
}


//unsigned long fileSize (char *filename){
//	FILE *fpText;
//	unsigned long fsize;
//	fpText = fopen(filename,"rb");
//	fsize=0;
//	if (fpText) {
//		fseek(fpText,0,2);
//		fsize= ftell(fpText);
//		fclose(fpText);
//		////fprintf(stderr,"fileSize = %ld",fsize);
//	}
//	return fsize;
//}

/***********************************************************************************************/

///*------------------------------------------------------------------
// Initialize the list of search patterns from the input parameters
// ------------------------------------------------------------------*/
// t_patterns initializePatterns(int numpatts, byte **patts, int *lens) {
// 	t_patterns mm;
// 	unsigned int p, initP;
// 	unsigned int m_p;
// 	byte *ch;
//
// 	mm = (t_patterns) malloc (sizeof(struct t_pats));
// 	mm->lmax =  MAX_CODEWORD_SIZE;
// 	mm->lmin = INFINITE;
//
// 	mm->size = numpatts;
//
// 	mm->patterns = (t_pattern *) malloc (sizeof(t_pattern) * mm->size);
//
//	for (p =0; p < mm->size;p++) {
// 		m_p =lens[p];
//		mm->patterns[p].size = m_p;
//
// 		ch = mm->patterns[p].word;
// 		strncpy(ch, patts[p], m_p);
//
//		mm->patterns[p].matches = 0;
//		mm->patterns[p].flag = p;
//
//		mm->lmin = MIN(mm->lmin,m_p);
//		mm->lmax = MAX(mm->lmax,m_p);
//	}
// 
//	//	fprintf(stderr,"\nparameters [%d]",mm->size);
//	//	fprintf(stderr,"\n lmin [%d]",mm->lmin);
//	//	fprintf(stderr,"\n lmax[%d]",mm->lmax);
//	 	
// 	return mm;
//}

t_patterns initilializePatternsFromCodes (byte *codes, uint numBytesCodes) {
 	t_patterns mm;
 	unsigned int p, initP;
 	unsigned int m_p;
 	byte *ch;
	
	uint *lens; byte **patts;
	lens = (uint *) malloc (sizeof(uint) * numBytesCodes); //upper bound. 
	patts = (byte **) malloc (sizeof(byte *) * (numBytesCodes+1)); //upper bound. 

	uint minm=MAX_CODEWORD_SIZE; //min len of pattern no larger than 10. Its ETDC ! ;)		
	uint numPats = 0;
	{ register uint i;
		register uint m=1;
		patts[0]=&(codes[0]);
		for (i=0; i< numBytesCodes; i++) {
			if (codes[i] < 128) { //a stopper
				lens[numPats]=m;
				if (m<minm) minm=m;  // updates min lenght of code
				numPats++;								
				patts[numPats]=&(codes[i+1]); //beginning of the next pattern
				m=1; //prepares for next pattern
			}
			else m++;		
		}
	}

 	mm = (t_patterns) malloc (sizeof(struct t_pats));
 	mm->size = numPats; 	
 	mm->patterns = (t_pattern *) malloc (sizeof(t_pattern) * mm->size);
 	mm->lmin = minm;


	for (p =0; p < mm->size;p++) {
 		m_p =lens[p];
		mm->patterns[p].size = m_p;
		mm->patterns[p].word = patts[p];
		mm->patterns[p].matches = 0;
		mm->patterns[p].flag = p;
		// 		ch = mm->patterns[p].word;
		// 		strncpy(ch, patts[p], m_p);
		
	}

	free (lens);
	free (patts);
 	return mm;
}




/*******************************************************************************/
/*****     OPERATIONS IN THE HORSPOOL's D-VECTOR    ****************************/
/*******************************************************************************/
/*------------------------------------------------------------------
  Initializes Horspool's d-vector (jumps for each letter)
 ------------------------------------------------------------------*/
void inicialize_d(t_patterns P, byte *d) {
	unsigned int c,i,m_i,k;

	for (c=0;c<256;c++) {d[c]=P->lmin;}

	for (i=0;i<P->size;i++) {

		m_i= P->patterns[i].size;
		for (k=0; k<m_i-1; k++) {
			c=P->patterns[i].word[k];
			d[ c ] = MIN ( d[c], m_i - k-1);
		}
	}
}


/*******************************************************************************/
/*****     OPERATIONS WITH THE TRIE         ************************************/
/*******************************************************************************/

/*------------------------------------------------------------------
 Initializes the trie used by the searcher, from the list of patterns
 ------------------------------------------------------------------*/
t_trie inicializeTrie(t_patterns P) {
	register unsigned int s,ch;
	register int j,i,m_i;
	register byte *c;
	t_trie trie;

	trie = (t_trie) malloc (sizeof(struct t_ttrie));

	//initialize trie to all zeroes:
	//REVISAR, ES POSIBLE QUE NO HAGA FALTA SI INICIALIZO DE CADA VEZ.
	for (s=0;s<MAX_STATES;s++) {
		trie->nodes[s].n=0;
		trie->nodes[s].f=NORMAL;

		for (ch=0;ch<256;ch++) {
			trie->transitions[s][ch]=ROOT_STATE;
		}
	}

	trie->zeroNode = 0;
	trie->stack =1;
	
	//adds patterns to the trie
	for (i=0; i<P->size; i++) {  //for all patterns i
		addToTrie(trie, P->patterns[i].word, P->patterns[i].size, P->patterns[i].flag);
	}

	return trie;
}


/*------------------------------------------------------------------
 Debuging only
 Shows the states and transitions of the trie
 ------------------------------------------------------------------*/
void printTrie(t_trie trie,int maxstate) 	{
	int z,k;

	fprintf(stderr,"\n\n DATA IN THE TRIE \n*******************");
	fprintf(stderr,"\n zeronode [%d] ", trie->zeroNode);
	fprintf(stderr,"\n STATES... ");
	for (z =0; z< maxstate; z++) {
		fprintf(stderr,"\n state[%d]:: n=%d :: flag=%d ",z,trie->nodes[z].n,trie->nodes[z].f);
		for (k=0;k<256;k++) {
			if (trie->transitions[z][k] !=ROOT_STATE) {
				fprintf(stderr,"(%d ---> %d).. ",k,trie->transitions[z][k]);
			}
		}
	}
}

/*------------------------------------------------------------------
 Adds a new pattern to the trie (states and transitions)
 ------------------------------------------------------------------ */
void addToTrie(t_trie trie, byte *nuevo, int size, unsigned int flag) {

	register byte *c;
	unsigned int state,newState;

	//while transitions are possible with the current pattern...

	state = ROOT_STATE;
	c = nuevo+size -1;  //pointer TO last char of the word

	while ((c>=nuevo) && (trie->transitions[state][*c] !=ROOT_STATE)) {
		trie->nodes[state].n ++;
		state = trie->transitions[state][(*c)];
		c--;  //pattern from right to left in the trie.
	}

	//add new states to the trie:     at this moment,...
	if (c<nuevo) {
	trie->nodes[state].f = flag;
	trie->nodes[state].n++;
	}
	else {
		while (c>=nuevo) {
			newState = trie->stack ++;
			trie->transitions[state][*c]= newState; //transition for current state,
							        // with character *c
			trie->nodes[state].n++; // OR also --> trie[s][*c].n ++;
			trie->nodes[newState].f=NORMAL;
			state = newState;
			c--;
		}
		//changes newState flag
		trie->nodes[newState].f = flag;
		trie->nodes[newState].n++;
	}
}

/*******************************************************************************/
/*******************************************************************************/
/*****     SEARCH PROCESS INSIDE  OF TEXT     **********************************/
/*******************************************************************************/
/*******************************************************************************/








/*------------------------------------------------------------------
 Performs search process inside a Buffer of text.
 ------------------------------------------------------------------ */

/** used in a block addresing inverted index.
  * startOffset is the offset of begin (the beginning of a block). So that a match occurring at position x, is 
  * actually an occurrence at position "startOffset + x" in the text of the inverted index */
uint searchInBufferETDC (byte *d, uint startOffset, byte *begin, byte *end, uint minLen, t_trie trie )	{

	register unsigned int state;
	register unsigned int flag;
	register unsigned long int cnt=0;

	register byte *cend;
	register byte *cbeg;
	register byte *cpos;
	register byte *cj;

	cpos=begin + minLen -1 ;
	cend=end;
	cbeg = begin;

	while ( 1 )   {
		state = ROOT_STATE;
		
		/*** skip loop  ***/
		while ( (cpos<cend) && (!trie->transitions[state][*cpos]) ) {
		cpos += d[*cpos];
		}
		
		if (cpos >=cend) return cnt;  // !!!!!!!!!!!!!
			
		/*** normal loop  ***/
		cj= cpos;

		//backwards check
		while(( cj>=cbeg )&&(trie->transitions[state][*cj]))  { 
			state = trie->transitions[state][*cj];
			flag  = trie->nodes[state].f;

			if (flag != NORMAL) {																	
				{
					cj--;  //a true match ?  ==> look at prev char.
					if ((*cj) <128) {
						cnt++;	
						break; //skips inner while.
					}
					cj++;  //not broken loop
				}
			}//flag != normal
			cj--;
		}//inner while
		cpos += d[*cpos];			
	} //while ( 1 )

}




//returnedPos makes no sense... but we want the same "interface" that in matchLeft.
int matchRight(uint pos, uint *IDs, uint numIDs, uint pivot, twcsa *wcsa, uint *returnedPos) {
	register int n = wcsa->textSize;
	byte **words;
	uint iters = numIDs - 1 - pivot;
	register int i=pos;
		
	words = wcsa->words;
	
	if (iters > 0) {
		byte *T = wcsa->text;
		while ((i<n)&&(T[i]>=128)) i++;//skips current code (the one that matched in horspool)
		i++;
		uint j=1;
		uint aID;   // an offset in words array
		int canonicalID;  //an offset into canonicals array.
		
		while ((j<=iters) && (i<n)){
			i=decode(T,i,&aID);
			if (isIndexedWord(wcsa,aID)) {
				canonicalID = parseWordToCanonicalID(wcsa, words[aID]);
				if (canonicalID != IDs[pivot + j]) 
					return 0;  //does not match.
				j++;  //continues matching process but 1 word less left.			
			}
			//else next iter.
		}//while
		
		if (j>iters) return 1;		
	}	
	return 1; //no iters ==> match.
} 


//matchLeft is the position of the first valid word of the pattern from the left (if a match occurs)
int matchLeft(uint pos, uint *IDs, uint numIDs, uint pivot, twcsa *wcsa, uint *returnedPos) {
	byte **words;
	uint iters = pivot;
	register int i;
	
	words = wcsa->words;
	*returnedPos =pos;
		
	if (iters > 0) {		
		byte *T = wcsa->text;
		i=pos-2; //byte prior to prev stopper
		while ((i>=0) && (T[i]>=128)) i--;  //points to prev stopper.
		
		uint j=1;
		uint aID;   // an offset in words array
		int canonicalID;  //an offset into canonicals array.
		int p=i+1;
				
		while ((j<=iters) && (p>=0)){
			p=decode(T,p,&aID);
			if (isIndexedWord(wcsa,aID)) {
				canonicalID = parseWordToCanonicalID(wcsa, words[aID]);
				if (canonicalID != IDs[pivot - j]) 
					return 0;  //does not match.
				j++;  //continues matching process but 1 word less left.		
				*returnedPos = i+1;	
			}
			
			//moves to the beginning of the prev code.
			i--;
			while ((i>=0) && (T[i] >=128)) i--;
			p=i+1;			
		}//while
		
		if (j>iters) return 1;		
	}	
	return 1; //no iters ==> match.
} 


/*------------------------------------------------------------------
 Performs search process inside a Buffer of text.
 ------------------------------------------------------------------ */

/** used in a block addresing inverted index.
  * startOffset is the offset of begin (the beginning of a block). So that a match occurring at position x, is 
  * actually an occurrence at position "startOffset + x" in the text of the inverted index 
  * RETURNS ALSO THE OFFSETS OF SUCH MATCHES 
      positions = vector of occurrences (offsets)
      size = number of occurrences */

//uint searchPositionsFullFile (byte *d, uint startOffset, byte *begin, byte *end, uint minLen,
//                         			t_trie trie ,  twcsa *wcsa,uint *IDs, uint numIDs,uint pivot, 
//                         			uint *positions, uint *size, uint rightFirst){
                         				
	uint searchPositionsFullFile (byte *d, uint startOffset, byte *begin, byte *end, uint minLen,
                      t_trie trie, twcsa *wcsa,uint *IDs, uint numIDs, uint pivot, uint *positions,
                       uint *size, uint rightFirst,int (*f1) (uint a, uint *b, uint c, uint d , twcsa *e, uint *f),
                       int (*f2) (uint x, uint* y, uint z, uint t, twcsa *s, uint *r)) {                         				
	register unsigned int state;
	register unsigned int flag;
	register unsigned long int cnt=0;

	register byte *cend;
	register byte *cbeg;
	register byte *cpos;
	register byte *cj;
	uint matchOffset;  //the offset in the file where the match occurs.

	cpos=begin + minLen -1 ;
	cend=end;
	cbeg = begin;

	while ( 1 )   {
		state = ROOT_STATE;
		
		/*** skip loop  ***/
		while ( (cpos<cend) && (!trie->transitions[state][*cpos]) ) {
		cpos += d[*cpos];
		}
		
		if (cpos >=cend) {*size = cnt; return cnt;}  // !!!!!!!!!!!!!
			
		/*** normal loop  ***/
		cj= cpos;

		//backwards check
		while(( cj>=cbeg )&&(trie->transitions[state][*cj]))  { 
			state = trie->transitions[state][*cj];
			flag  = trie->nodes[state].f;

			if (flag != NORMAL) {																	
				{
					cj--;  //a true match ?  ==> look at prev char.
					if ((*cj) <128) {
						uint canditatePos = startOffset + cj +1 -cbeg; 
						uint isMatch=1;
						matchOffset=canditatePos;
//						isMatch &= matchLeft(canditatePos, IDs, numIDs,  pivot, wcsa, &matchOffset); //calculates the offset of the match
//						isMatch &= matchRight(canditatePos, IDs, numIDs,  pivot, wcsa, NULL); 
						isMatch &= (*f1)(canditatePos, IDs, numIDs,  pivot, wcsa, &matchOffset); //calculates the offset of the match
						isMatch &= (*f2)(canditatePos, IDs, numIDs,  pivot, wcsa, &matchOffset); 
						
						if (isMatch) {
							positions[cnt] = matchOffset;//canditatePos;
							cnt++;	
						}
						break; //skips inner while.
					}
					cj++;  //not broken loop
				}
			}//flag != normal
			cj--;
		}//inner while
		cpos += d[*cpos];			
	} //while ( 1 )

}

















//
///*------------------------------------------------------------------
//  Initializes Horspool's d-vector (jumps for each letter)
// ------------------------------------------------------------------*/
//
//void inicialize_d(byte *code, unsigned int len, byte *d) {
//	unsigned int c,i,m_i,k;
//
//	for (c=0;c<256;c++) {d[c]=len;}
//
//	for (k=0; k<len-1; k++) {
//		c=code[k];
//		d[c] = MIN ( d[c], len - k-1);
//	}
//}
//
//
//
///*------------------------------------------------------------------
// * Performs search process over the whole file.
//------------------------------------------------------------------ */
//uint searchFullFile (unsigned char* texto, unsigned long int totalBytes, byte *code, int len){
//	register int i;
//	unsigned int matches=0;
//	byte d[256];
//	register byte *cend;
//	register byte *cpos;
//	register byte *cj;
//	register int j;
//	register unsigned int m;
//	
//	inicialize_d(code, len, d);
//		
//	m=len;
//	
//	cpos=texto + len -1;
//	cend=texto + totalBytes;
//
//	while (1)   {
//		j=m-1;
//		
//		/*** skip loop  ***/		
//		while ((cpos<cend) && ( *cpos != code[j] ))  {cpos += d[*cpos];}
//		//fprintf(stderr,"matches %d cend %x cpos %x\n",matches,cend,cpos);
//		if(cpos>=cend)
//			return matches;	
//		/*** normal loop  ***/
//		cj= cpos-1;
//		j--;
//				
//		while ((j>=0) && ((*cj) == code[j])) {	j--;cj--;}  //check backwards
//		
//		if ((j==-1) && ((*cj) <128)) {  //if the prev byte is a stopper 
//				matches ++;			
//		}
//		cpos += d[*cpos];
//			
//	} //while ( 1 )
//
//	return matches;
//	
//	
//	
//	return matches;
//} //searchFullFile
//
//
//
//
//
//
//
///*------------------------------------------------------------------
// * Performs search process over the whole file.
//------------------------------------------------------------------ */
//unsigned int searchKAppeareance(unsigned char* texto, unsigned long int totalBytes, byte *code, int len, unsigned int order){
//	register int i;
//	byte d[256];
//	register byte *cend;
//	register byte *cpos;
//	register byte *cj;
//	register int j;
//	register unsigned int m;
//	
//	inicialize_d(code, len, d);
//		
//	m=len;
//	
//	cpos=texto + len -1;
//	cend=texto + totalBytes;
//
//	while (1)   {
//		j=m-1;
//		
//		/*** skip loop  ***/		
//		while ((cpos<cend) && ( *cpos != code[j] ))  {cpos += d[*cpos];}
//		//fprintf(stderr,"matches %d cend %x cpos %x\n",matches,cend,cpos);
//		if(cpos>=cend)
//			return -1;	
//		/*** normal loop  ***/
//		cj= cpos-1;
//		j--;
//				
//		while ((j>=0) && ((*cj) == code[j])) {	j--;cj--;}  //check backwards
//		
//		if ((j==-1) && ((*cj) <128)) {  //if the prev byte is a stopper 
//				return cpos-texto;			
//		}
//		cpos += d[*cpos];
//			
//	} //while ( 1 )
//
//	return -1;
//	
//	//fprintf(stderr, "... search FINISHED with %d matches!!\n", matches);;fflush(stderr);
//	return -1;
//
//}
//
//
//
///*---------------------------------------------------------------------
// * Performs search process over the whole file returning the positions
//----------------------------------------------------------------------- */
//
////uint searchPositionsFullFile (byte* texto, ulong totalBytes, byte *code, int len, uint *positions, uint size) {
//uint searchPositionsFullFile (byte *d, uint startOffset, byte *cbeg, byte *cend, byte *code, int len, uint *positions, uint *size) {
//	register int i;
//	unsigned int matches=0;
//	unsigned long int cnt = 0;
//	
////	byte d[256];
//	//register byte *cend;
//	register byte *cpos;
//	register byte *cj;
//	register int j;
//	register unsigned int m;
//	
////	inicialize_d(code, len, d);
//		
//	m=len;
//	
//	cpos = cbeg + len -1;
//	//cend=cbeg + totalBytes;
//
//	while (1)   {
//		j=m-1;
//		
//		/*** skip loop  ***/		
//		while ((cpos<cend) && ( *cpos != code[j] ))  {cpos += d[*cpos];}
//				////fprintf(stderr,"matches %d cend %x cpos %x\n",matches,cend,cpos);
//		if(cpos>=cend){
//		//	printf( "\n... search FINISHED, %d appeareances!!!\n", cnt);;fflush(stderr);
//			*size = cnt;
//			return cnt;	
//		}
//		/*** normal loop  ***/
//		cj= cpos-1;
//		j--;
//				
//		while ((j>=0) && ((*cj) == code[j])) {	j--;cj--;}  //check backwards
//		
//		if ((j==-1) && ((*cj) <128)) {  //if the prev byte is a stopper 
//				//positions[cnt++] = startOffset+cpos-cbeg;		
//				positions[cnt++] = startOffset+cj+1-cbeg;		
//		//		printf("\n ### match at position %d",startOffset+cj+1-cbeg);	
//		//		printf("\n[%d][%d][%d][%d][%d][%d]",*(cpos-3),*(cpos-2),*(cpos-1),*(cpos),*(cpos+1),*(cpos+2));	
//		}
//		cpos += d[*cpos];
//			
//	} //while ( 1 )
//
//	//	printf( "\n... search FINISHED, %d appeareances!!!\n", cnt);;fflush(stderr);
//		*size = cnt;
//		return cnt;		
//}


//		//
//		/////*---------------------------------------------------------------------
//		//// * Performs search process over the whole file returning snippets
//		////----------------------------------------------------------------------- */
//		////
//		////unsigned int searchSnippetFullFile (unsigned char* texto, unsigned long int totalBytes, byte *code, int len, unsigned int snippetsize,unsigned *snippets, unsigned int size, char *buffer, unsigned int bsize){
//		////	
//		////	register int i;
//		////	unsigned int matches=0;
//		////		
//		////	unsigned long int cnt = 0,cnt1=0,cnt2=0, numPalab=0,inipos=0;
//		////		
//		////	byte d[256];
//		////	register byte *cend;
//		////	register byte *cpos;
//		////	register byte *cj;
//		////	register int j;
//		////	register unsigned int m;
//		////	
//		////	inicialize_d(code, len, d);
//		////		
//		////	m=len;
//		////	
//		////	cpos=texto + len -1;
//		////	cend=texto + totalBytes;
//		////
//		////	while ((inipos<bsize))   {
//		////		j=m-1;
//		////		
//		////		/*** skip loop  ***/		
//		////		while ((cpos<cend) && ( *cpos != code[j] ))  {cpos += d[*cpos];}
//		////		//fprintf(stderr,"matches %d cend %x cpos %x\n",matches,cend,cpos);
//		////		if(cpos>=cend)
//		////			return cnt;	
//		////		/*** normal loop  ***/
//		////		cj= cpos-1;
//		////		j--;
//		////				
//		////		while ((j>=0) && ((*cj) == code[j])) {	j--;cj--;}  //check backwards
//		////		
//		////		if ((j==-1) && ((*cj) <128)) {
//		////			 //if the prev byte is a stopper 
//		////			 uint wordsbefore;
//		////				snippets[cnt++]= inipos;
//		////				wordsbefore = snippetsize/2-1;
//		////					cj--;
//		////					while((wordsbefore)&&(cj>=texto)){
//		////						while ((*cj) >= 128) {  //move cpos until previous stopper
//		////							cj--;
//		////						}
//		////						wordsbefore--;
//		////						cj--;
//		////					}
//		////					cj+=2;
//		////				inipos = decodeFromPosition(texto,totalBytes,cj-texto,snippetsize,buffer,bsize,inipos);
//		////		
//		////		}
//		////		cpos += d[*cpos];
//		////			
//		////	} //while ( 1 )
//		////
//		////
//		////		return cnt;
//		////}
//		//
//		//
//		//
//		///*
//		//
//		//	uint decodeFromPosition(byte* texto, ulong totalBytes,
//		//			 int position, uint snippet, char *buffer, uint size, int inipos){
//		//	register long int i,cont;
//		//	int nivelActual,curr,k,previousAlfaN = 0;
//		//	uint longbuffer,j,offset,cnt2;
//		//	int leng;
//		//	unsigned char readbyte;
//		//	unsigned long previousbytes = 0;
//		//	byte * pbeg;
//		//	pbeg = &texto[position];
//		//	//Decode snippet
//		//	longbuffer = inipos;
//		//	//fprintf(stderr,"Empezando a descomprimir %d palabras, desde %d\n",snippet,position);
//		//	
//		// 	for ( cont = 0; cont < snippet ;cont++ )   {
//		// 	
//		//			//fprintf(stderr,"\n %d %d\n",cont, snippet);
//		//				readbyte = (*pbeg);
//		//				pbeg++;
//		//				//previousbytes = 0;
//		//				j=0;
//		//				leng=0;
//		//				//fprintf(stderr,"\nAntes while :%d, readbyte %x:\n",j, readbyte);
//		//				while ( readbyte >= 128)   {
//		//					j = j * 128 + (readbyte - 128);
//		//					readbyte = (*pbeg);
//		//					pbeg++;
//		//					leng++;
//		//					//fprintf(stderr,"Dentro while :%d, readbyte %x:\n",j, readbyte);
//		//				}// inner while
//		//				j = j * 128 + readbyte;
//		//				
//		//				j += TABLABASE[leng];
//		//			//pbeg++;
//		//
//		//			//fprintf(stderr,"\n pos = [%ld] [%s]",j,hash[words[j]].word);
//		//			//fprintf(stderr,"%s ",hash[words[j]].word);
//		//	
//		//			if((longbuffer + 2 + hash[words[j]].len)>size){
//		//				buffer[longbuffer++]='\0';
//		//				longbuffer = size;
//		//				return longbuffer;
//		//			} 
//		//
//		//			curr= _Valid[hash[words[j]].word[0]];
//		//
//		//			if(curr && previousAlfaN) {
//		//				buffer[longbuffer++]= ' ';
//		//			}
//		//			previousAlfaN=curr;
//		//			for(k=0;k<hash[words[j]].len;k++)
//		//				buffer[longbuffer++]=hash[words[j]].word[k];
//		//			
//		//		}
//		//		
//		//	buffer[longbuffer++]='\0';	
//		//	return longbuffer;
//		//
//		//}
//		//
//		//*/
//		//
