
/* This is the Paice stemming algorithm.
*/


#ifndef ALG_PAICE
#define ALG_PAICE

#include <stdio.h>
#include <string.h>
#include <stdlib.h>


#define maxrulesz 10 /* Maximum length of rule text */
#define maxwdsz 25 /* Maximum length of word stemmable */
#define maxsuffsz 8 /* Maximum length of suffix */
#define maxlinelength 80 /* Maximun length of line read from file */
#define true 1 /* Boolean true */
#define false 0 /* Boolean false */
#define stop 2 /* Stop here */
#define continue 1 /* Continue with next rule */
#define notapply 0 /* Rule did not apply */
#define notintact 3 /* Word no longer intact */
#define blank '?' /* For when replace string is empty */

struct rule {
char text[maxwdsz]; /* To return stemmer output */
char keystr[maxsuffsz]; /* Key string,ie,suffix to remove */
char repstr[maxsuffsz]; /* string to replace deleted letters */
char intact; /* Boolean-must word be intact? */
char cont; /* Boolean-continue with another rule? */
int rulenum; /* Line number of rule in rule list file */
char protect; /* Boolean-protect this ending? */
char deltotal; /* Delete how many letters? */
struct rule *next; /* Next item in linked list */
};
struct rule ttable[26];


char addrule(struct rule r);
struct rule stemPaice(char *word);
int tblindex(char *s);
int applyrule(struct rule *r,char *word,int isintact);
int rulewalk(char *word,int is_intact,struct rule *used);
int isvalidstr(char *s);
struct rule makerule(char *s,int line);
void readrules(FILE *fp);
void inittable();
void printtable();
int flagerror(char *s);
int isvowel(char s);
int isconsonant(char s);
int acceptable(char *s);


#endif
